﻿Imports System.Windows.Forms.Screen
Imports System.Data.SqlClient

Public Class Form1
  Const ErrorTitle As String = "エラー"
  Private DataAdapter As SqlDataAdapter
  Private GroupItem As List(Of String) =
    New List(Of String)
  Private PhoneGroupItem As List(Of String) =
    New List(Of String)
  Private Position As Integer

  Private FilteredValue As Boolean
  Private Property Filtered As Boolean
    Get
      Return FilteredValue
    End Get
    Set(value As Boolean)
      FilteredValue = value
      If value Then
        DataGridViewMain.RowsDefaultCellStyle.
          BackColor = Color.Aqua
      Else
        DataGridViewMain.RowsDefaultCellStyle.
          BackColor = Color.White
        Dim index As Integer = -1
        If BindingSource1.Count > 0 Then _
          index = CType(BindingSource1.Current, 
            DataRowView).Row.Item(0)

        BindingSource1.RemoveFilter()

        If index > -1 Then
          index = BindingSource1.Find("Id", index)
          BindingSource1.Position = index
        End If
      End If
      UpdateTitleBar()
    End Set
  End Property

  Private ConnectedValue As Boolean
  Property Connected As Boolean
    Get
      Return ConnectedValue
    End Get
    Set(value As Boolean)
      ConnectedValue = value
      UpdateTitleBar()
    End Set
  End Property

  Private EditingValue As Boolean
  Property Editing As Boolean
    Get
      Return EditingValue
    End Get
    Set(value As Boolean)
      EditingValue = value
      If value Then
        ButtonNew.Text = "編集の中止"
      Else
        ButtonNew.Text = "新規入力"
      End If

      If BindingSource1.Count < 1 Then
        ButtonOverwrite.Enabled = False
      Else
        ButtonOverwrite.Enabled = value AndAlso
          LabelId.Text <> "" AndAlso OwnCurrent()
      End If

      ButtonSaveAsNew.Enabled = value
      ButtonFirst.Enabled = Not value
      ButtonPrevious.Enabled = Not value
      ButtonNext.Enabled = Not value
      ButtonLast.Enabled = Not value
      TabPageGrid.Enabled = Not value
    End Set
  End Property

  Private Property ShowMenu As Boolean
    Get
      Return My.Settings.ShowMenu
    End Get
    Set(ByVal value As Boolean)
      My.Settings.ShowMenu = value
      ToolStripMenuItemSettingShowMenu.Checked = value
      MenuStrip1.Visible = value
    End Set
  End Property

  Private Sub Form1_Load(ByVal sender As System.Object,
    ByVal e As System.EventArgs) Handles MyBase.Load

    'Me.Text = Application.ProductName '不要と思われる
    'Me.KeyPreview = True
    Me.MinimumSize = New Size(600, 400) '大きくした
    Me.Size = My.Settings.Size

    'ShowMenu = My.Settings.ShowMenu
    ShowMenu = True
    ToolStripMenuItemSettingShowMenu.Visible = False

    If Me.Left < GetWorkingArea(Me).Left OrElse
      Me.Left >= GetWorkingArea(Me).Right Then
      Me.Left = 100
    End If
    If Me.Top < GetWorkingArea(Me).Top OrElse
      Me.Top >= GetWorkingArea(Me).Bottom Then
      Me.Top = 100
    End If

    With DataGridViewMain
      .Dock = DockStyle.Fill
      .MultiSelect = False
      .ReadOnly = True
      .AllowUserToAddRows = False
      .AllowUserToDeleteRows = False
      .DataSource = BindingSource1
      .ScrollBars = ScrollBars.Both
      .RowHeadersVisible = False
    End With

    TextBoxNameLast.Tag = 1
    TextBoxNameFirst.Tag = 2
    TextBoxNameOthers.Tag = 3
    TextBoxPostalCode.Tag = 4
    TextBoxAddress1.Tag = 5
    TextBoxAddress2.Tag = 6
    TextBoxAddress3.Tag = 7
    TextBoxPhone1.Tag = 8
    ComboBoxPhoneGroup1.Tag = 9
    TextBoxPhone2.Tag = 10
    ComboBoxPhoneGroup2.Tag = 11
    TextBoxPhone3.Tag = 12
    ComboBoxPhoneGroup3.Tag = 13
    TextBoxPhone4.Tag = 14
    ComboBoxPhoneGroup4.Tag = 15
    ComboBoxGroup1.Tag = 16
    ComboBoxGroup2.Tag = 17
    ComboBoxGroup3.Tag = 18
    ComboBoxGroup4.Tag = 19
    TextBoxMemo.Tag = 20
    LabelId.Text = ""

    If My.Settings.UserName = "" Then _
      ToolStripMenuItemSettingUserName_Click(
        sender, e)

    Connected = False
    If My.Settings.ServerName <> "" Then _
      Connected = Connect(My.Settings.ServerName)

    Dim s As String = My.Settings.ColumnWidth
    If s <> "" Then
      Dim columnWidth() As String = s.Split(","c)
      For i As Integer = 0 To _
        DataGridViewMain.ColumnCount - 1
        DataGridViewMain.Columns(i).Width =
          columnWidth(i)
      Next
    End If

    Editing = False
    Filtered = False
  End Sub

  Private Sub Form1_FormClosed(ByVal sender As System.Object,
    ByVal e As System.Windows.Forms.FormClosedEventArgs
    ) Handles MyBase.FormClosed

    Me.WindowState = FormWindowState.Normal
    My.Settings.Size = Me.Size

    If Connected Then
      Dim s As String = ""
      For i As Integer = 0 To DataGridViewMain.ColumnCount - 1
        s &= DataGridViewMain.Columns(i).Width
        If i <> DataGridViewMain.ColumnCount - 1 Then s &= ","
      Next
      My.Settings.ColumnWidth = s
      Disconnect()
    End If
  End Sub

  'Private Sub Form1_KeyDown(ByVal sender As System.Object,
  '  ByVal e As System.Windows.Forms.KeyEventArgs
  '  ) Handles MyBase.KeyDown

  '  If e.Alt Then MenuStrip1.Visible = True
  'End Sub

  Private Sub MenuStrip1_MenuDeactivate(
    ByVal sender As System.Object, ByVal e As System.EventArgs
    ) Handles MenuStrip1.MenuDeactivate

    If Not ShowMenu Then MenuStrip1.Visible = False
  End Sub

  Private Sub ToolStripMenuItemFileExit_Click(
    ByVal sender As System.Object, ByVal e As System.EventArgs
    ) Handles ToolStripMenuItemFileExit.Click

    Application.Exit()
  End Sub

  Private Sub ToolStripMenuItemSettingShowMenu_Click(
    ByVal sender As System.Object, ByVal e As System.EventArgs
    ) Handles ToolStripMenuItemSettingShowMenu.Click

    ShowMenu = Not ShowMenu
  End Sub

  Private Sub ToolStripMenuItemHelpReadme_Click(
    ByVal sender As System.Object, ByVal e As System.EventArgs
    ) Handles ToolStripMenuItemHelpReadme.Click


    Dim s As String = System.IO.Path.GetDirectoryName(
      Application.ExecutablePath)
    If Not s.EndsWith("\") Then s &= "\"
    s &= "readme.txt"
    If System.IO.File.Exists(s) Then
      System.Diagnostics.Process.Start(s)
    Else
      MsgBox(s & "が見付かりません")
    End If
  End Sub

  Private Sub ToolStripMenuItemHelpWeb_Click(
    ByVal sender As System.Object, ByVal e As System.EventArgs
    ) Handles ToolStripMenuItemHelpWeb.Click

    System.Diagnostics.Process.Start(
      "http://software.nikkeibp.co.jp/")
  End Sub

  Private Sub ToolStripMenuItemHelpVersion_Click(
    ByVal sender As System.Object, ByVal e As System.EventArgs
    ) Handles ToolStripMenuItemHelpVersion.Click

    Dim s As String
    s = Application.ProductName & " " &
      Application.ProductVersion
    s &= "（2011/06/27）" & vbCrLf
    s &= My.Application.Info.Copyright & vbCrLf & vbCrLf

    s &= "実行ファイル：" & Application.ExecutablePath & "（"
    If Environment.Is64BitProcess Then
      s &= "64"
    Else
      s &= "32"
    End If
    s &= "ビットのプロセスとして稼働）" & vbCrLf

    s &= ".NET Framework（ビルド時）：" &
      System.Reflection.Assembly.GetExecutingAssembly().
      ImageRuntimeVersion & vbCrLf
    s &= ".NET Framework（現在）：" &
      System.Runtime.InteropServices.RuntimeEnvironment.
      GetSystemVersion & vbCrLf

    s &= "オペレーティングシステム：" &
      My.Computer.Info.OSFullName &
      My.Computer.Info.OSVersion & " "
    If Environment.Is64BitOperatingSystem Then
      s &= "64"
    Else
      s &= "32"
    End If
    s &= "ビット"

    MessageBox.Show(s, "バージョン情報")
  End Sub

  Function Connect(serverName As String) As Boolean
    Dim connectString As String =
      "Integrated Security=SSPI;" &
      "Initial Catalog=Address01;" &
      "Data Source=" & serverName
    Dim selectString As String =
      "select * from TableMain"
    Try
      DataAdapter = New SqlDataAdapter(
        selectString, connectString)
      Dim commandBuilder As New SqlCommandBuilder(
        DataAdapter)

      Dim dataTable As New DataTable()
      DataAdapter.Fill(dataTable)
      BindingSource1.DataSource = dataTable

    Catch ex As Exception
      MessageBox.Show(ex.Message.ToString(), "エラー")
      Return False
    End Try

    Dim columnName() As String = {
      "#", "姓", "名", "名前その他",
      "郵便番号", "住所1", "住所2", "住所3",
      "電話番号1", "電話属性1", "電話番号2",
      "電話属性2", "電話番号3", "電話属性3",
      "電話番号4", "電話属性4", "グループ1",
      "グループ2", "グループ3", "グループ4",
      "メモ", "入力者", "更新日時"}
    For i As Integer = 0 To columnName.Count - 1
      DataGridViewMain.Columns(i).HeaderText =
        columnName(i)
    Next
    DataGridViewMain.Columns.Add("", "")

    InitializeComboBoxGroup()
    InitializeComboBoxPhoneGroup()

    LabelId.DataBindings.Add(
      "Text", BindingSource1, "Id")
    TextBoxNameLast.DataBindings.Add(
      "Text", BindingSource1, "NameLast")
    TextBoxNameFirst.DataBindings.Add(
      "Text", BindingSource1, "NameFirst")
    TextBoxNameOthers.DataBindings.Add(
      "Text", BindingSource1, "NameOthers")
    TextBoxPostalCode.DataBindings.Add(
      "Text", BindingSource1, "PostalCode")
    TextBoxAddress1.DataBindings.Add(
      "Text", BindingSource1, "Address1")
    TextBoxAddress2.DataBindings.Add(
      "Text", BindingSource1, "Address2")
    TextBoxAddress3.DataBindings.Add(
      "Text", BindingSource1, "Address3")
    TextBoxPhone1.DataBindings.Add(
      "Text", BindingSource1, "Phone1")
    TextBoxPhone2.DataBindings.Add(
      "Text", BindingSource1, "Phone2")
    TextBoxPhone3.DataBindings.Add(
      "Text", BindingSource1, "Phone3")
    TextBoxPhone4.DataBindings.Add(
      "Text", BindingSource1, "Phone4")
    ComboBoxPhoneGroup1.DataBindings.Add(
      "Text", BindingSource1, "Phone1Group")
    ComboBoxPhoneGroup2.DataBindings.Add(
      "Text", BindingSource1, "Phone2Group")
    ComboBoxPhoneGroup3.DataBindings.Add(
      "Text", BindingSource1, "Phone3Group")
    ComboBoxPhoneGroup4.DataBindings.Add(
      "Text", BindingSource1, "Phone4Group")
    ComboBoxGroup1.DataBindings.Add(
      "Text", BindingSource1, "Group1")
    ComboBoxGroup2.DataBindings.Add(
      "Text", BindingSource1, "Group2")
    ComboBoxGroup3.DataBindings.Add(
      "Text", BindingSource1, "Group3")
    ComboBoxGroup4.DataBindings.Add(
      "Text", BindingSource1, "Group4")
    TextBoxMemo.DataBindings.Add(
      "Text", BindingSource1, "Memo")

    Return True
  End Function

  Sub InitializeComboBoxGroup() '今回改良
    Dim s As String = ""
    GroupItem.Clear()
    For i As Integer = 0 To _
      DataGridViewMain.RowCount - 1
      For j As Integer = 16 To 19
        s = DataGridViewMain(j, i).Value.ToString()
        If (s <> "") AndAlso
          (-1 = GroupItem.IndexOf(s)) Then _
          GroupItem.Add(s)
      Next
    Next
    UpdateComboBoxGroup()
  End Sub

  Sub UpdateComboBoxGroup()
    GroupItem.Sort()
    ComboBoxGroup1.Items.Clear()
    ComboBoxGroup1.Items.AddRange(GroupItem.ToArray())
    ComboBoxGroup2.Items.Clear()
    ComboBoxGroup2.Items.AddRange(GroupItem.ToArray())
    ComboBoxGroup3.Items.Clear()
    ComboBoxGroup3.Items.AddRange(GroupItem.ToArray())
    ComboBoxGroup4.Items.Clear()
    ComboBoxGroup4.Items.AddRange(GroupItem.ToArray())
  End Sub

  Sub InitializeComboBoxPhoneGroup() '今回改良
    Dim s As String = ""
    PhoneGroupItem.Clear()
    For i As Integer = 0 To DataGridViewMain.RowCount - 1
      For j As Integer = 9 To 15 Step 2
        s = DataGridViewMain(j, i).Value.ToString()
        If (s <> "") AndAlso
          (-1 = PhoneGroupItem.IndexOf(s)) Then _
          PhoneGroupItem.Add(s)
      Next
    Next
    UpdateComboBoxPhoneGroup()
  End Sub

  Sub UpdateComboBoxPhoneGroup()
    PhoneGroupItem.Sort()
    ComboBoxPhoneGroup1.Items.Clear()
    ComboBoxPhoneGroup1.Items.AddRange(
      PhoneGroupItem.ToArray())
    ComboBoxPhoneGroup2.Items.Clear()
    ComboBoxPhoneGroup2.Items.AddRange(
      PhoneGroupItem.ToArray())
    ComboBoxPhoneGroup3.Items.Clear()
    ComboBoxPhoneGroup3.Items.AddRange(
      PhoneGroupItem.ToArray())
    ComboBoxPhoneGroup4.Items.Clear()
    ComboBoxPhoneGroup4.Items.AddRange(
      PhoneGroupItem.ToArray())
  End Sub

  Sub Disconnect()
    For Each control In TabPageInput.Controls
      If (TypeOf (control) Is Label) Then
        If CType(control, Label).Name = "LabelId" Then
          CType(control, Label).DataBindings.Clear()
          CType(control, Label).Text = ""
        End If
      ElseIf (TypeOf (control) Is TextBox) Then
        CType(control, TextBox).DataBindings.Clear()
        CType(control, TextBox).Text = ""
      ElseIf (TypeOf (control) Is ComboBox) Then
        CType(control, ComboBox).DataBindings.Clear()
        CType(control, ComboBox).Text = ""
        CType(control, ComboBox).Items.Clear()
      End If
    Next

    Filtered = False '今回追加
    BindingSource1.DataSource = vbNull
    DataAdapter.Dispose()
    DataGridViewMain.Update()
    DataGridViewMain.Columns.Clear()
    Connected = False
  End Sub

  Private Sub ToolStripMenuItemSettingUserName_Click(
    sender As System.Object, e As System.EventArgs
    ) Handles ToolStripMenuItemSettingUserName.Click

    Dim name As String = ""
    Do
      name = InputBox(
        "ユーザー名を入力してください。" & vbCrLf &
        "例「田中一郎」", , My.Settings.UserName)
    Loop While (name = "" AndAlso My.Settings.UserName = "")
    If name <> "" Then My.Settings.UserName = name
  End Sub

  Private Sub ToolStripMenuItemSettingServerName_Click(
    sender As System.Object, e As System.EventArgs
    ) Handles ToolStripMenuItemSettingServerName.Click

    Dim name As String = InputBox(
      "サーバー名を入力してください。" & vbCrLf &
      "例「localhost\sqlexpress」", ,
      My.Settings.ServerName)
    If name <> "" AndAlso
      name <> My.Settings.ServerName Then
      If Connected Then Disconnect()
      If Connect(name) Then
        My.Settings.ServerName = name
        Connected = True
      Else
        My.Settings.ServerName = ""
      End If
    End If
  End Sub

  Private Sub DataGridViewMain_DoubleClick(
    sender As System.Object, e As System.EventArgs
    ) Handles DataGridViewMain.DoubleClick

    TabControlMain.SelectedTab = TabPageInput
    'TabControlMain.SelectedIndex = 1
  End Sub

  Private Sub ButtonFirst_Click(sender As System.Object,
    e As System.EventArgs) Handles ButtonFirst.Click

    BindingSource1.MoveFirst()
  End Sub

  Private Sub ButtonPrevious_Click(sender As System.Object,
    e As System.EventArgs) Handles ButtonPrevious.Click

    BindingSource1.MovePrevious()
  End Sub

  Private Sub ButtonNext_Click(sender As System.Object,
    e As System.EventArgs) Handles ButtonNext.Click

    BindingSource1.MoveNext()
  End Sub

  Private Sub ButtonLast_Click(sender As System.Object,
    e As System.EventArgs) Handles ButtonLast.Click

    BindingSource1.MoveLast()
  End Sub

  Private Sub ButtonNew_Click(sender As System.Object,
    e As System.EventArgs) Handles ButtonNew.Click

    If Editing Then
      BindingSource1.CancelEdit()
      BindingSource1.Position = Position

      If BindingSource1.Count < 1 Then
        BindingSource1.AddNew()
        BindingSource1.CancelEdit()
      End If
    Else
      Position = BindingSource1.Position
      BindingSource1.AddNew()
    End If
    Editing = Not Editing
  End Sub

  Private Sub TextBoxNameLast_TextChanged(
    sender As System.Object, e As System.EventArgs
    ) Handles TextBoxNameLast.TextChanged,
    TextBoxNameFirst.TextChanged,
    TextBoxPostalCode.TextChanged,
    TextBoxPhone4.TextChanged,
    TextBoxPhone3.TextChanged,
    TextBoxPhone2.TextChanged,
    TextBoxPhone1.TextChanged,
    TextBoxNameOthers.TextChanged,
    TextBoxMemo.TextChanged,
    TextBoxAddress3.TextChanged,
    TextBoxAddress2.TextChanged,
    TextBoxAddress1.TextChanged

    Dim edit As Boolean = False
    If BindingSource1.Count > 0 Then
      If CType(BindingSource1.Current, DataRowView).Row.
        Item(CType(sender, TextBox).Tag).ToString() <> _
        CType(sender, TextBox).Text Then edit = True
    Else
      If CType(sender, TextBox).Text <> "" Then _
        edit = True
    End If

    If edit Then
      Position = BindingSource1.Position  'バグ対応
      Editing = True
    End If
  End Sub

  Private Sub ComboBoxPhoneGroup1_TextChanged(
    sender As System.Object, e As System.EventArgs
    ) Handles ComboBoxPhoneGroup1.TextChanged,
    ComboBoxPhoneGroup4.TextChanged,
    ComboBoxPhoneGroup3.TextChanged,
    ComboBoxPhoneGroup2.TextChanged,
    ComboBoxGroup4.TextChanged,
    ComboBoxGroup3.TextChanged,
    ComboBoxGroup2.TextChanged,
    ComboBoxGroup1.TextChanged

    Dim edit As Boolean = False
    If BindingSource1.Count > 0 Then
      If CType(BindingSource1.Current, DataRowView).
        Row.Item(CType(sender, ComboBox).Tag).ToString() _
        <> CType(sender, ComboBox).Text Then edit = True
    Else
      If CType(sender, ComboBox).Text <> "" Then _
        edit = True
    End If

    If edit Then
      Position = BindingSource1.Position  'バグ対応
      Editing = True
    End If
  End Sub

  Private Sub ButtonOverwrite_Click(
    sender As System.Object, e As System.EventArgs
    ) Handles ButtonOverwrite.Click

    CType(BindingSource1.Current, DataRowView).Row.
      Item(21) = My.Settings.UserName
    CType(BindingSource1.Current, DataRowView).Row.
      Item(22) = DateTime.Now()
    BindingSource1.EndEdit()
    DataAdapter.Update(
      CType(BindingSource1.DataSource, DataTable))
    UpdateComboBoxItem()
    Editing = False
  End Sub

  Sub UpdateComboBoxItem()
    Dim newGroupItem As Boolean = False
    Dim newPhoneGroupItem As Boolean = False

    For Each control In TabPageInput.Controls
      If (TypeOf (control) Is ComboBox) Then
        Dim cb As ComboBox = control
        If cb.Text = "" Then Continue For
        Select Case cb.Tag
          Case 16, 17, 18, 19
            If -1 = GroupItem.IndexOf(cb.Text) Then
              GroupItem.Add(cb.Text)
              newGroupItem = True
            End If
          Case Else
            If -1 = PhoneGroupItem.IndexOf(cb.Text) Then
              PhoneGroupItem.Add(cb.Text)
              newPhoneGroupItem = True
            End If
        End Select
      End If
    Next

    If newGroupItem Then UpdateComboBoxGroup()
    If newPhoneGroupItem Then UpdateComboBoxPhoneGroup()
  End Sub

  Private Sub ButtonSaveAsNew_Click(
    sender As System.Object, e As System.EventArgs
    ) Handles ButtonSaveAsNew.Click

    If LabelId.Text <> "" OrElse
      BindingSource1.Count < 1 Then
      Dim data(20) As String
      For Each control In TabPageInput.Controls
        If (TypeOf (control) Is TextBox) Then
          Dim tb As TextBox = control
          data(tb.Tag) = tb.Text
        End If
        If (TypeOf (control) Is ComboBox) Then
          Dim cb As ComboBox = control
          data(cb.Tag) = cb.Text
        End If
      Next
      BindingSource1.CancelEdit()
      BindingSource1.AddNew()
      For i As Integer = 1 To 20
        CType(BindingSource1.Current, DataRowView).
          Row.Item(i) = data(i)
      Next
    End If
    ButtonOverwrite_Click(sender, e)

    Dim dataTable As New DataTable
    DataAdapter.Fill(dataTable)
    BindingSource1.DataSource = dataTable

    Filtered = False
    BindingSource1.MoveLast()
    UpdateTitleBar()
  End Sub

  Private Sub TabControlMain_SelectedIndexChanged(
    sender As System.Object, e As System.EventArgs
    ) Handles TabControlMain.SelectedIndexChanged

    If Editing AndAlso TabControlMain.SelectedIndex = 0 Then
      MessageBox.Show("編集中は一覧表示を利用できません",
        ErrorTitle)
      TabControlMain.SelectedIndex = 1
    End If
  End Sub

  Private Sub ToolStripMenuItemSearchId_Click(
    sender As System.Object, e As System.EventArgs
    ) Handles ToolStripMenuItemSearchId.Click

    'BindingSource1.Filter = "Id = 1"
    'MsgBox("OKボタンを押すと絞り込みを解除します")
    'BindingSource1.RemoveFilter()

    'MsgBox("OKボタンを押すとレコードを削除します")
    'BindingSource1.RemoveCurrent()
    'DataAdapter.Update(CType(BindingSource1.DataSource, DataTable))

    Dim id As Integer
    Dim s As String =
      InputBox("検索したいID番号を入力してください",
        "ID番号検索")
    If s <> "" Then
      Try
        id = Int32.Parse(s)
      Catch ex As Exception
        MessageBox.Show(
          "「" & s & "」は数値ではありません",
          ErrorTitle)
        Exit Sub
      End Try

      If id < 1 Then
        MessageBox.Show("ID番号は1以上です",
          ErrorTitle)
        Exit Sub
      End If

      BindingSource1.Filter = "Id = " & id.ToString()
      If BindingSource1.Count < 1 Then
        MsgBox("ID番号が「" & s &
          "」のレコードはありません")
        Filtered = False
      Else
        Filtered = True
      End If
    End If
  End Sub

  Private Sub ToolStripMenuItemSearchDisplayAll_Click(
    sender As System.Object, e As System.EventArgs
    ) Handles ToolStripMenuItemSearchDisplayAll.Click

    If Filtered Then Filtered = False
  End Sub

  Private Sub ToolStripMenuItemSearch_DropDownOpening(
    sender As System.Object, e As System.EventArgs
    ) Handles ToolStripMenuItemSearch.DropDownOpening

    ToolStripMenuItemSearchDisplayAll.Enabled = Filtered
    Dim existData As Boolean = BindingSource1.Count > 0
    ToolStripMenuItemSearchId.Enabled = existData
    ToolStripMenuItemSearchGroup.Enabled = existData
    ToolStripMenuItemSearchFreeWord.Enabled = existData
  End Sub

  Private Sub ToolStripMenuItemSearchGroup_Click(
    sender As System.Object, e As System.EventArgs
    ) Handles ToolStripMenuItemSearchGroup.Click

    With FormSelectGroup
      .ListBoxMain.Items.Clear()
      .ListBoxMain.Items.AddRange(GroupItem.ToArray())
      .Group = ""
      If DialogResult.OK = .ShowDialog() Then
        Dim s As String = .Group
        BindingSource1.Filter = "Group1 = '" & s &
          "' or Group2 = '" & s & "' or Group3 = '" &
          s & "' or Group4 = '" & s & "'"

        If BindingSource1.Count < 1 Then
          MsgBox("グループが「" & s &
            "」のレコードはありません")
          Filtered = False
        Else
          Filtered = True
        End If
      End If
    End With
  End Sub

  Private Sub ToolStripMenuItemSearchFreeWord_Click(
    sender As System.Object, e As System.EventArgs
    ) Handles ToolStripMenuItemSearchFreeWord.Click

    Dim s As String =
      InputBox("検索したい単語を入力してください",
        "自由語検索")
    If s <> "" Then
      Dim t As String = " like '*" & s & "*' "
      t = "NameLast" & t & "or NameFirst" & t &
        "or NameOthers" & t & "or PostalCode" & t &
        "or Address1" & t & "or Address2" & t &
        "or Address3" & t & "or Phone1" & t &
        "or Phone1Group" & t & "or Phone2" & t &
        "or Phone2Group" & t & "or Phone3" & t &
        "or Phone3Group" & t & "or Phone4" & t &
        "or Phone4Group" & t & "or Group1" & t &
        "or Group2" & t & "or Group3" & t &
        "or Group4" & t & "or Memo" & t &
        "or Owner" & t
      BindingSource1.Filter = t
      If BindingSource1.Count < 1 Then
        MsgBox("「" & s &
          "」を含むレコードは見付かりませんでした")
        Filtered = False
      Else
        Filtered = True
      End If
    End If
  End Sub

  Private Sub UpdateTitleBar()
    Dim s As String = Application.ProductName
    If Connected Then
      s = s & " - " & My.Settings.ServerName &
        " (" & BindingSource1.Count.ToString() & "/" &
        CType(BindingSource1.DataSource, DataTable).
        Rows.Count.ToString() & ")"
    End If
    Me.Text = s
  End Sub

  Private Sub ToolStripMenuItemSettingDisconnect_Click(
    sender As System.Object, e As System.EventArgs
    ) Handles ToolStripMenuItemSettingDisconnect.Click

    Disconnect()
    My.Settings.ServerName = ""
  End Sub

  Private Sub ToolStripMenuItemFileDelete_Click(
    sender As System.Object, e As System.EventArgs
    ) Handles ToolStripMenuItemFileDelete.Click

    Dim r As DataRow = CType(BindingSource1.Current, 
      DataRowView).Row
    Dim id As Integer = r.Item(0)
    Dim lastName As String = r.Item(1).ToString()
    Dim firstName As String = r.Item(2).ToString()
    Dim s As String = "「" & id & " " & lastName &
      " " & firstName & "」を削除しますか？"
    If DialogResult.OK = MessageBox.Show(s,
      "レコード削除の確認",
      MessageBoxButtons.OKCancel) Then

      BindingSource1.RemoveCurrent()
      DataAdapter.Update(CType(
        BindingSource1.DataSource, DataTable))
      UpdateTitleBar()
    End If
  End Sub

  Private Sub ToolStripMenuItemFile_DropDownOpening(
    sender As System.Object, e As System.EventArgs
    ) Handles ToolStripMenuItemFile.DropDownOpening

    Dim result As Boolean = False
    If BindingSource1.Count > 0 AndAlso
      Not Editing AndAlso OwnCurrent() Then _
      result = True
    ToolStripMenuItemFileDelete.Enabled = result
  End Sub

  Function OwnCurrent()
    Return My.Settings.UserName = CType(
      BindingSource1.Current, DataRowView).
      Row.Item(21).ToString()
  End Function

  Private Sub DataGridViewMain_DataError(
    sender As System.Object, e As System.Windows.Forms.
    DataGridViewDataErrorEventArgs
    ) Handles DataGridViewMain.DataError

    If BindingSource1.Count < 1 Then Exit Sub
  End Sub


End Class
